/*

Subscribes to events sns topic and sends email notifications to appropriate users

*/
const env = process.env;
const fnName = env.AWS_LAMBDA_FUNCTION_NAME;
console.log(`Loading function ${fnName}...`);

const appId = 'com.endpointclosinginc.endpoint';
const settings = {
  gcm: {
    id: env.GOOGLE_API_KEY,
  },
  apn: {
    token: {
      key: env.APNS_CERT.replace(/\\n/g, '\n'),
      keyId: env.APNS_KEY_ID,
      teamId: '4L9GU5N75G',
    },
    production: true,
  },
};

const PushNotifications = require('node-pushnotifications');
const push = new PushNotifications(settings);

const firebaseAdmin = require('firebase-admin');

const firebaseConfig = {
  "type": env.TYPE,
  "project_id": env.PROJECT_ID,
  "private_key_id": env.PRIVATE_KEY_ID,
  "private_key": env.PRIVATE_KEY,
  "client_email": env.CLIENT_EMAIL,
  "client_id": env.CLIENT_ID,
  "auth_uri": env.AUTH_URI,
  "token_uri": env.TOKEN_URI,
  "auth_provider_x509_cert_url": env.AUTH_PROVIDER_X509_CERT_URL,
  "client_x509_cert_url": env.CLIENT_X509_CERT_URL,
}

const firebase = firebaseAdmin.initializeApp({
  credential: firebaseAdmin.credential.cert({
    "type": "service_account",
    "project_id": "api-7274845276839901808-109715",
    "private_key_id": "cb5391ed3180e3ea44e42c2595b60e681171d595",
    "private_key": "-----BEGIN PRIVATE KEY-----\nMIIEvAIBADANBgkqhkiG9w0BAQEFAASCBKYwggSiAgEAAoIBAQDaJAJqOq0VQyQs\njEbjkfiDCoL3PFeKmiNxlNNnWY0zXw0FZHZFlPQJIy4pcDcGmCjrICvPELoaiiny\ntaQpeo18QgLT9DDwPEV1x1VxRFLZu3e7AHs8ZQ2GDeFxYMNiCdaK74Xx10xYCiNy\nS+jtMASS5+6bgazlE3gohGmWZCE+WfrjwA3WmcUveBIjiE8O+u6dmtQR81/DHvzB\n3xlAGwjIwbYsJOUNbm9xberiiexLqTuIX0DhnmYBtnFJbG1XZFVKycN32eQG5uax\nh/cCS+ApF0cHKQnsmUzdzix+13PMLkyMwtNktY6vomFDwSK5ZkezhFCh7k6dZ5AM\nZAuuxEAJAgMBAAECggEAEaTn027/Y3t3YFQQrXpigw+VWXPrx8X2bSA4JkFNJWqA\nMN9inU0HnSVCPVn6gBcheNKKFe5OLfSJdpHVygDD6MOlG2mXu21rQol27Nm1fYTc\nkcdfmxpjCOS0B2SSgSpMYcIEep6AahRDMDeZdZ/p6suwQNXxEGQDVtGjrGVZIVll\nvtMLKqTOBHiAblZum//cTxVZ2Bfbe5xMSp2wp9gTmbk4WpHoCA3Q8+FY4PGQeDTQ\nb8j4CGF5qe3XZLoGRlX7J/iKO5WcFvZ5ShdjuV6mNrUXIymdbSqNViXKM+zKBVu8\nyyqpH1hMvY3LU7YeFlutOuu3EfZ6sOkk3mYoYZhLpQKBgQD2a49WbrwAJvjQjz8g\nKhXj/0INkr6a97v3DTJuzl8iFiF73Iklhc5pxE5TIIaG7LNEZita1xfWjveT3Trm\nbaMiEN4jDs7R7f6SUfzI4QEOdJq607CkqresxiFjQ5SkxQFs7HkokfiOQBLq24qF\nIwmGGWpQWc4jIOLmbVJPgEDWnQKBgQDinwEcjCf/QPvHGj8mE2gmzfbrim29RjlU\nXz11+ckpERayNbXi28F5IfFsexnaRsnLRS4LM8OOlFyUfwD0qbJyYmrKLJhr5k8X\nDrIX9G8F8P/t/s1T1oWW/t/HeHDzpswNw13/OVNX6RXba7io34SvzRP6F3GCRWtS\nuiYKgnidXQKBgC0y+366HwfUHi17KPQIZC2G46HDueyI5lRhek+y0OZasteaUxmr\n2nmyBT/gJmzXO+ae6vLlozy6ypS3rpcXoyWbfHNnwu3kvp4uJbTe+KejIcKFE9CQ\nc9JgIT2o5rn2XNWS5oJXjATjodSsYlMbYyLSxJpqbpIo9RWZFdD5UGtNAoGAKdLM\ngrc/HnWgweMPKnjEbPzwCBJZJGhUZkTZc+9wd5rGxIbzFXYXI8Lm6m1hnQ4ZaeFP\nmROpkKPC3kj+JSk4XLHbIYrPaoJrsEavCYq7/q22nfa7cDCUIQTSyd5pgh4TZKrc\nqyCqR/wlY4Ri5Q+zTjqb6DjxYuhq4S6nnKLtnaUCgYBhQm5y3ZaHheXRhfOfSPXX\nhduKuiJWfVfeFLj4Qgo8Gaqp+d7HGrAa7Oaou9twdZ6Y14gFbYqOE939HMJI1AEG\nHQzroX9LOIvT3lttuVWMuCeJ4qNGEdofXUmgrf+LTEDc4NtlSCt0Xlc4OQyd+qF3\nyOgAmC5XprXRoUEn6+0wZw==\n-----END PRIVATE KEY-----\n",
    "client_email": "firebase-adminsdk-5gxxp@api-7274845276839901808-109715.iam.gserviceaccount.com",
    "client_id": "114310675347160252990",
    "auth_uri": "https://accounts.google.com/o/oauth2/auth",
    "token_uri": "https://oauth2.googleapis.com/token",
    "auth_provider_x509_cert_url": "https://www.googleapis.com/oauth2/v1/certs",
    "client_x509_cert_url": "https://www.googleapis.com/robot/v1/metadata/x509/firebase-adminsdk-5gxxp%40api-7274845276839901808-109715.iam.gserviceaccount.com"
  }
  ),
  databaseURL: env.DATABASE_URL
})

const isLocal = !!env.LOCALSTACK_HOSTNAME;
const isProduction = env.NODE_ENV === 'production';

const AWS = require('aws-sdk');
const config = new AWS.Config({
  accessKeyId: env.AWS_ACCESS_KEY_ID,
  secretAccessKey: env.AWS_SECRET_ACCESS_KEY,
  region: env.AWS_REGION,
});
const ddb = isLocal
  ? new AWS.DynamoDB({ endpoint: `http://${env.LOCALSTACK_HOSTNAME}:4569` })
  : new AWS.DynamoDB();

const { executer, helpers } = require('@endpoint/lambda-lib');
const h = helpers;
const he = executer;

exports.lambda_handler = async (event, context, callback) => {
  console.log(`event: ${h.obj2Str(event)}`);
  context.callbackWaitsForEmptyEventLoop = false;
  const snsData = he.validEventHandler(event);
  const messageAttributes = snsData.MessageAttributes;
  const principalTargets = JSON.parse(messageAttributes.principalTargets.Value);

  if (
    !he.targetsExistForExecuter(principalTargets, ['preferred_notifications'])
  ) {
    callback(
      null,
      `(${fnName}) No targets for this executer: ${JSON.stringify(
        principalTargets,
      )}`,
    );

    return `(${fnName}) No targets for this executer: ${JSON.stringify(
      principalTargets,
    )}`;
  }

  // Preferred not to go through getEventData as no roundtrip to db required
  const eventData = {
    transactionId: messageAttributes.transactionId.Value,
    principalId: messageAttributes.principalId.Value,
    copy: JSON.parse(messageAttributes.copy.Value),
    eventName: messageAttributes.eventName.Value,
  };

  // TODO abstract this out into helpersExecuter
  let res;

  try {
    const transactionRoles = await h.getTransactionRoles(
      ddb,
      eventData.transactionId,
    );

    let _preferredPushUserIds = [];

    Object.keys(transactionRoles).forEach(role => {
      // check if principal is a certain role, and proceed with that principalRole
      // hint: principal can play multiple roles :-)
      if (transactionRoles[role].includes(eventData.principalId)) {
        const principalRole = /Agent/.test(role) ? 'agent' : role.slice(0, -1); // role is pluralized in transactionRoles

        _preferredPushUserIds.push(
          ...he.parseTargetUserObjs(
            principalTargets[principalRole]['preferred_notifications'],
            transactionRoles,
            eventData.principalId,
            role,
          ),
        );
      }
    });

    const preferredPushUserIds = _preferredPushUserIds
      .map(obj => obj.userId)
      .unique();

    res = await pushHandler(preferredPushUserIds, eventData);
  } catch (err) {
    const message = err && typeof err === 'object' ? err.stack || err : err;

    console.log(`(${fnName}) failed: ${message}`);
    callback(null, `(${fnName}) failed: ${message}`);
  }

  console.log(`(${fnName}) succeeded: ${res}`);
  callback(null, `(${fnName}) succeeded: ${res}`);
};

/* Helpers localized to email executer */

function pushHandler(targetIds, eventData) {
  console.log(`pushHandler: targetIds: ${JSON.stringify(targetIds)}`);
  console.log(`pushHandler: eventData: ${JSON.stringify(eventData)}`);
  return Promise.all(
    targetIds.map(targetId => {
      return new Promise(async (resolve, reject) => {
        try {
          h.getUser(ddb, targetId)
          .then(async user => {
            if (shouldSendPush(user)) {
              const eventCopy =
                user.user_id === eventData.principalId
                  ? eventData.copy.principal
                  : eventData.copy.other;
              // using SMS copy
              console.log(
                `pushHandler: call pushTransport: user: ${JSON.stringify(
                  user,
                )}`,
              );
              console.log(
                `pushHandler: call pushTransport: eventCopy: ${JSON.stringify(
                  eventCopy,
                )}`,
              );
              
              await pushTransport(
                targetId,
                user.devices,
                eventData.eventName,
                eventCopy.sms,
              );

              resolve(`Sent notifications to ${targetId} 🏁🏁🏁🏁`)
            } else {
              resolve(`Avoided sending push notifications to ${
                user.email
              } because:
                i. user does not have any device tokens stored
              `);
            }
          })
        }
        catch(err){
          console.log(`Error in push-executer index.pushHandler method ${err}`)
          throw err
        }
      });
    }),
  );
}

async function pushTransport(targetId, deviceTokens, pushTitle, pushMessage) {
  console.log('Sending push notification');
  console.log(`tokens: ${JSON.stringify(deviceTokens)}`);
  console.log(`pushTitle: ${JSON.stringify(pushTitle)}`);
  console.log(`pushMessage: ${JSON.stringify(pushMessage)}`);

  const iOSTokens = deviceTokens.filter(i => i.platform.toLowerCase() === 'ios' && i.token.length > 0);
  const androidTokens = deviceTokens.filter(i => i.platform.toLowerCase() === 'android' && i.token.length > 0);

  const iOSNotifications = iOSTokens.length > 0 ? Array.from(await push.send(iOSTokens , {    
      topic: appId,
      title: pushTitle,
      body: pushMessage,
  })) : [];
  
    const androidNotifications = androidTokens.length > 0 ? Array.from(await firebase.messaging().sendToDevice(androidTokens, {
      title: pushTitle,
      body : pushMessage
    })) : [];

   const results = [...iOSNotifications , ... androidNotifications];
   
   results.forEach(result => {
     if( (result.messageId && result.messageId.length) || (result.success && result.success == 1) ){
       console.log(`Sent notifications to ${targetId} , platform : ${result.messageId ? 'android' : 'iOS'} - ${h.obj2Str(results)}`,)
     } else if ( (result.failure && result.error) || (result.error && !result.messageId) ){
      console.log(`Error sending notifications to ${targetId} -- ${h.obj2Str(results)}`,)
     }
   })
    return results
}

function shouldSendPush(user) {
  const validDevices = user.devices ? user.devices.filter(i => i.token && i.platform && i.platform.length && i.token.length) : [];
  const shouldSend = validDevices.length ? true : false;
  return shouldSend;
}
